/***************************************************************************
                          volume.cpp  -  description
                             -------------------
    begin                : Thu Jul 18 2002
    copyright            : (C) 2002 by Krzysztof Lichota
    email                : lichota@mimuw.edu.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "volume.h"

#include <linux/soundcard.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>

#include <qstring.h>
#include <kmessagebox.h>
#include <klocale.h>

//OSS control code taken from asmixer

void KnobVolumeCtrl_OSS::setVolume(int volume)
{
	int mixer_fd;
	VolumeControl volControl;
	
	volControl.volume.left=volControl.volume.right=(unsigned char)volume;

	//FIXME: get device name from configuration
	QString mixerDeviceName = "/dev/mixer";
	mixer_fd = open(mixerDeviceName, O_RDWR, 0);

	if (mixer_fd == -1)
	{
		KMessageBox::information(0, i18n("Cannot open mixer device\"" + mixerDeviceName + "\""));
		return;
	}

	if (ioctl(mixer_fd, SOUND_MIXER_READ_DEVMASK, &volControl.supported) == -1)
	{
		volControl.supported = 0xffff; // Assume all are supported
	}

	volControl.mixer_id = SOUND_MIXER_VOLUME;

	if (ioctl(mixer_fd, MIXER_WRITE(volControl.mixer_id), &volControl.volume) == -1)
	{
		KMessageBox::information(0, i18n("Cannot do ioctl() on mixer device"));
		return;
	}
	::close(mixer_fd);
}

int KnobVolumeCtrl_OSS::getVolume()
{
	//TODO
	return 0;
}
